//#include <ESP8266.h>
#include <SPI.h>
#include <Wire.h>
//#include "TimerOne.h"
#include <MiniGrafx.h>
#include <Carousel.h>
#include <ILI9341_SPI.h>
#include <SoftwareSerial.h> 
#include <Adafruit_Sensor.h>
#include <Adafruit_BME280.h>
#include "weathericons.h"
#include "ArialRounded.h"
#define MINI_BLACK 0
#define MINI_WHITE 1
#define MINI_YELLOW 2
#define MINI_BLUE 3
#define MINI_GREEN 4
#define MINI_ORANGE 5
#define MINI_RED 6
#define MINI_PURPLE 7
#define MINI_DARKGREY 8


// defines the colors usable in the paletted 16 color frame buffer
uint16_t palette[] = {ILI9341_BLACK, // 0
                      ILI9341_WHITE, // 1
                      ILI9341_YELLOW, // 2
                      0x7E3C,         //ILI9341_BLUE lighter
                      ILI9341_GREEN,
                      ILI9341_ORANGE,
                      ILI9341_RED,
                      ILI9341_PURPLE,
                      ILI9341_DARKGREY,
                      }; //3

int SCREEN_WIDTH = 240;
int SCREEN_HEIGHT = 320;
// Limited to 4 colors due to memory constraints
int BITS_PER_PIXEL = 2; // 2^2 =  4 colors


#define ESP8266
/*
// These are the pins used for the UNO
// for Due/Mega/Leonardo use the hardware SPI pins (which are different)
#define _sclk 13
#define _miso 12
#define _mosi 11
#define _cs 1
#define _dc 2
#define _rst 4
*/
// The display uses hardware SPI, plus #9 & #10
#define TFT_CS D1
#define TFT_DC D2
#define TFT_LED D8

const char version[] = "v1.0";

uint8_t ledPin = 5;
uint8_t pwm = 255;
uint8_t textSize = 2;
uint8_t rotation = 2;


#define SEALEVELPRESSURE_HPA        (1013.25)
#define LOCATION_ALTITUDE     320
#define SUNNY       (SEALEVELPRESSURE_HPA-(LOCATION_ALTITUDE/8.5)+10)
#define MOSTLYSUNNY (SEALEVELPRESSURE_HPA-(LOCATION_ALTITUDE/8.5))
#define MOSTLYCLOUDY (SEALEVELPRESSURE_HPA-(LOCATION_ALTITUDE/8.5)-10)

SoftwareSerial mySerial(D3,D4);    //RxD, TxD

ILI9341_SPI tft = ILI9341_SPI(TFT_CS, TFT_DC);
MiniGrafx gfx = MiniGrafx(&tft, BITS_PER_PIXEL, palette);
//Carousel carousel(&gfx, 0, 0, 240, 100);
//Adafruit_BME280 bme; // I2C

//FrameCallback frames[] = { drawForecast1, drawForecast2, drawForecast3 };
//int frameCount = 3;
float Temperature, Humidity, Gas;
//uint32_t Gas;
uint32_t Pressure;
uint16_t IAQ=0;
int16_t  Altitude;
uint8_t IAQ_accuracy;
unsigned char Re_buf[30], counter=0;
unsigned char sign=0;

void setup()
{
        Serial.begin(115200);
        Serial.println("Welcome to the WEATHER-BOARD");
        pinMode(TFT_LED, OUTPUT);
        digitalWrite(TFT_LED, HIGH);    // HIGH to Turn on;
        // initialize the display
        gfx.init();
        gfx.fillBuffer(MINI_BLACK);
        gfx.commit();

        //carousel.setFrames(frames, frameCount);
       // carousel.disableAllIndicators();

        gfx.setRotation(rotation);
        gfx.setFont(ArialMT_Plain_24);
        gfx.setTextAlignment(TEXT_ALIGN_LEFT);
        gfx.setColor(MINI_WHITE);
        gfx.drawString(15, 200, "WEATHER-BOARD");
        gfx.drawString(110, 222, version);
        //gfx.drawPalettedBitmapFromPgm(20, 5, ThingPulseLogo);
        gfx.drawPalettedBitmapFromPgm(80, 25, mostlycloudy);
        gfx.commit();
        delay(1000);
        gfx.drawPalettedBitmapFromPgm(80, 25, mostlysunny);
        gfx.commit();
        delay(250);
        gfx.drawPalettedBitmapFromPgm(80, 25, sunny);
        gfx.commit();
        /*
        delay(500);
        gfx.drawPalettedBitmapFromPgm(80, 25, rain);
        gfx.commit();
        delay(500);
        gfx.drawPalettedBitmapFromPgm(80, 25, mostlysunny);
        gfx.commit();*/
        delay(250);
        gfx.fillBuffer(MINI_BLACK);
        gfx.commit();

        gfx.setFont(ArialMT_Plain_16);
	      displayLabel();
        delay(2000);
        mySerial.begin(9600);
        mySerial.listen(); 

        mySerial.write(0XA5); 
        mySerial.write(0X55);    
        mySerial.write(0X3F);    
        mySerial.write(0X39); 
        delay(100); 
 
        mySerial.write(0XA5); 
        mySerial.write(0X56);    
        mySerial.write(0X02);    
        mySerial.write(0XFD);
        delay(100);  
}
/*
uint8_t read8(byte _i2caddr, byte reg)
{
	      byte value;
	      Wire.beginTransmission((uint8_t)_i2caddr);
	      Wire.write((uint8_t)reg);
	      Wire.endTransmission();
	      Wire.requestFrom((uint8_t)_i2caddr, (byte)1);
	      value = Wire.read();
	      Wire.endTransmission();
	      return value;
}

void initPins()
{
	pinMode(ledPin, OUTPUT);
	pinMode(3, OUTPUT);
	pinMode(4, OUTPUT);
	pinMode(6, OUTPUT);
	pinMode(7, INPUT);
	pinMode(A0, INPUT);
	//pinMode(A1, INPUT);
    //    pinMode(A2, INPUT);

	analogWrite(ledPin, pwm);
}

void timerCallback()
{
//	readBtn();
	timer++;
}
*/
void sendToHost()
{

		Serial.print(Temperature);
		Serial.print("\ew6");
		Serial.print(Humidity);
		Serial.print("\ew7");
		Serial.print(Pressure);
		Serial.print("\ew8");
		Serial.print(IAQ);
    Serial.print("\n");
}

void getMCU680()
{
    unsigned char i=0, sum=0;
    uint16_t temp1=0;
    int16_t temp2=0;
    uint32_t temp3=0;
    
     if(Re_buf[0]==0x5A&&Re_buf[1]==0x5A )        
     {    
            for(i=0;i<19;i++)
            sum+=Re_buf[i]; 
            if(sum==Re_buf[i] ) 
            {
                     temp2=(Re_buf[4]<<8|Re_buf[5]);   
                     Temperature=(float)temp2/100;
                     temp1=(Re_buf[6]<<8|Re_buf[7]);
                     Humidity=(float)temp1/100; 
                     Pressure=(((uint32_t)Re_buf[8]<<16)|((uint16_t)Re_buf[9]<<8)|Re_buf[10])/100;
                     IAQ_accuracy= (Re_buf[11]&0xf0)>>4;
                     IAQ=((Re_buf[11]&0x0F)<<8)|Re_buf[12];
                     temp3=((uint32_t)Re_buf[13]<<24)|((uint32_t)Re_buf[14]<<16)|((uint16_t)Re_buf[15]<<8)|Re_buf[16];
                     Gas=(float)temp3/1000;
                     Altitude=(Re_buf[17]<<8)|Re_buf[18]; 
                     Serial.print("Temperature:");
                     Serial.print(Temperature);
                     Serial.print("C"); 
                     Serial.print(", Humidity:"); 
                     Serial.print(Humidity);
                     Serial.print("%"); 
                     Serial.print(", Pressure:"); 
                     Serial.print(Pressure);
                     Serial.print("hPa"); 
                     if(IAQ_accuracy)
                     {    
                        Serial.print(", IAQ:");
                        Serial.print(IAQ);
                     } 
                     Serial.print(", Gas:"); 
                     Serial.print(Gas);
                     Serial.print("kOhm"); 
                     Serial.print(", Altitude:"); 
                     Serial.print(Altitude);
                     Serial.print("mnpm\r\n");                        
            }                    
   }  
}
void displayLabel()
{
    gfx.setColor(MINI_YELLOW);
    gfx.drawString(10, 200, "BME680");
    gfx.drawString(5, 220, "Temperatura : ");
    gfx.drawString(5, 240, "Cisnienie :");
    gfx.drawString(5, 260, "Wilgotnosc :");
    gfx.drawString(5, 280, "Powietrze :");
    gfx.commit();
    //tft.drawRect(240, 10, 70, 30, 870);
}
void displayMCU680()
{
        //czyszczenie pod nowe wyniki - drawString nadpisuje - nie czysci
        gfx.setColor(MINI_BLACK);
        gfx.fillRect(110, 220, 130, 100);
        //gfx.clear();       - lekkie mrgniecie lepiej zakryc fragment
        //gfx.fillBuffer(MINI_BLACK);
        //gfx.commit();

        gfx.setColor(MINI_BLUE); 
        gfx.drawString(110, 220, String(Temperature-1.5)+" C"); 
        gfx.drawString(110, 240, String(Pressure)+" hPa");
        gfx.drawString(110, 260, String(Humidity)+" %");
        //gfx.drawString(110, 280, String(IAQ));

        //analiza jakosci powietrza
        if(IAQ<50)      {gfx.drawString(110, 280, "DOBRE");}
        else if(IAQ<100){gfx.drawString(110, 280, "SREDNIE");}
        else if(IAQ<150){gfx.drawString(110, 280, "KIEPSKIE");}
        else if(IAQ<200){gfx.drawString(110, 280, "ZLE");}
        else if(IAQ<300){gfx.drawString(110, 280, "BARDZO ZLE");}
        else            {gfx.drawString(110, 280, "TRAGICZNE");}
        gfx.commit();
}

void loop(void)
{
        while (mySerial.available()) 
        {   
              Re_buf[counter]=(unsigned char)mySerial.read();
    
              if(counter==0&&Re_buf[0]!=0x5A) return;         
              if(counter==1&&Re_buf[1]!=0x5A)
              {
                    counter=0;
                    return;
              }           
              counter++;       
              if(counter==20)               
              {    
                    counter=0;                  
                    sign=1;
              }      
      }
      if(sign)
      {  
              sign=0; 
              getMCU680();
              displayMCU680();
      }
      
      if(Pressure>SUNNY)      {gfx.drawPalettedBitmapFromPgm(80, 25, sunny);}
      else if(Pressure>MOSTLYSUNNY) {gfx.drawPalettedBitmapFromPgm(80, 25, mostlysunny);}
      else if(Pressure>MOSTLYCLOUDY) {gfx.drawPalettedBitmapFromPgm(80, 25, mostlycloudy);}
      else                  {gfx.drawPalettedBitmapFromPgm(80, 25, rain);}
      gfx.commit();

      /*
      gfx.drawString(0, 0, "clear"); 
      gfx.drawPalettedBitmapFromPgm(80, 25, clear);
      gfx.commit();
      delay(2000);
      gfx.drawString(0, 0, "cloudy");
      gfx.drawPalettedBitmapFromPgm(80, 25, cloudy);
      gfx.commit();
      delay(2000);
      gfx.drawString(0, 0, "flurries");
      gfx.drawPalettedBitmapFromPgm(80, 25, flurries);
      gfx.commit();
      delay(2000);
      gfx.drawString(0, 0, "fog");
      gfx.drawPalettedBitmapFromPgm(80, 25, fog);
      gfx.commit();
      delay(2000);
      gfx.drawString(0, 0, "hazy");
      gfx.drawPalettedBitmapFromPgm(80, 25, hazy);
      gfx.commit();
      delay(2000);
      gfx.drawString(0, 0, "most cloudy");
      gfx.drawPalettedBitmapFromPgm(80, 25, mostlycloudy);
      gfx.commit();
      delay(2000);
      gfx.drawString(0, 0, "most sunny");
      gfx.drawPalettedBitmapFromPgm(80, 25, mostlysunny);
      gfx.commit();
      delay(2000);
      gfx.drawString(0, 0, "part cloudy");
      gfx.drawPalettedBitmapFromPgm(80, 25, partlycloudy);
      gfx.commit();
      delay(2000);
      gfx.drawString(0, 0, "part sunny");
      gfx.drawPalettedBitmapFromPgm(80, 25, partlysunny);
      gfx.commit();
      delay(2000);
      gfx.drawString(0, 0, "rain");
      gfx.drawPalettedBitmapFromPgm(80, 25, rain);
      gfx.commit();
      delay(2000);
      gfx.drawString(0, 0, "sleet");
      gfx.drawPalettedBitmapFromPgm(80, 25, sleet);
      gfx.commit();
      delay(2000);
      gfx.drawString(0, 0, "snow");
      gfx.drawPalettedBitmapFromPgm(80, 25, snow);
      gfx.commit();
      delay(2000);
      gfx.drawString(0, 0, "sunny");
      gfx.drawPalettedBitmapFromPgm(80, 25, sunny);
      gfx.commit();
      delay(2000);
      gfx.drawString(0, 0, "tstorms");
      gfx.drawPalettedBitmapFromPgm(80, 25, tstorms);
      gfx.commit();
      delay(2000);
      gfx.drawString(0, 0, "unknown");
      gfx.drawPalettedBitmapFromPgm(80, 25, unknown);
      gfx.commit();
      delay(2000);
*/
		  //sendToHost();
      delay(10000);

}
